<template>
  <div class="p-2">
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="22">
            <span>标签类别信息列表</span>
          </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['customer:tagCategory:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="tagCategoryList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="标签类别" align="center" prop="tagCategoryName" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['customer:tagCategory:edit']">编辑</el-button>
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['customer:tagCategory:remove']"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改标签类别信息对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="tagCategoryFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="类别名称" prop="tagCategoryName">
          <el-input v-model="form.tagCategoryName" placeholder="请输入类别名称" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="TagCategory" lang="ts">
import { listTagCategory, getTagCategory, delTagCategory, addTagCategory, updateTagCategory } from '@/api/customer/customerCategory/tagCategory';
import { TagCategoryVO, TagCategoryQuery, TagCategoryForm } from '@/api/customer/customerCategory/tagCategory/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const tagCategoryList = ref<TagCategoryVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const tagCategoryFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: TagCategoryForm = {
  id: undefined,
  tagCategoryName: undefined,
  status: undefined,
  remark: undefined,
  platformCode: undefined
};
const data = reactive<PageData<TagCategoryForm, TagCategoryQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    tagCategoryName: undefined,
    status: undefined,
    platformCode: undefined,
    params: {}
  },
  rules: {
    tagCategoryName: [{ required: true, message: '标签分类不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询标签类别信息列表 */
const getList = async () => {
  loading.value = true;
  const res = await listTagCategory(queryParams.value);
  tagCategoryList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  tagCategoryFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: TagCategoryVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加标签类别信息';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: TagCategoryVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getTagCategory(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改标签类别信息';
};

/** 提交按钮 */
const submitForm = () => {
  tagCategoryFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateTagCategory(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addTagCategory(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: TagCategoryVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除标签类别信息编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delTagCategory(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'customer/tagCategory/export',
    {
      ...queryParams.value
    },
    `tagCategory_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
